﻿<?php
/**	plugin.cpinfo.php
 *	Checkpoint info plugin for XAseco by Reaby, 2009
 *	Configuration file: cpinfo.xml
 *	Copy this file to xaseco plugins folder
 */	
Aseco::registerEvent('onStartup', 'cpinfo_startup');
Aseco::registerEvent('onCheckpoint', 'cpinfo_checkpoint');
Aseco::registerEvent('onPlayerFinish', 'cpinfo_finish');
Aseco::registerEvent('onNewChallenge', 'cpinfo_sync');
Aseco::registerEvent('onEndRound', 'cpinfo_end');
Aseco::addChatCommand('cpinfo','cpinfo-releated commands');

function chat_cpinfo($aseco, $command) {
	$params = explode(' ', $command['params'], 2);
	$player = $command['author'];
    if ($params[0] == "on" || $params[0] == "enable") {
	$player->cpinfo = 1;
	$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}CPinfo enabled'), $player->login);
	return;
	}
    if ($params[0] == "off" || $params[0] == "disable") {
	$player->cpinfo = 0;
	$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}CPinfo disabled'), $player->login);
	return;
	}
	$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> Usage: /cpinfo on or /cpinfo off'), $player->login);
}

function cpinfo_startup($aseco, $command)
   {
   global $aseco;
   global $cpinfo;

   $cpinfo= new cpinfo_class();
   $cpinfo->Aseco = $aseco;
   $cpinfo->Startup();
   
   } 

function cpinfo_sync($aseco, $command) {
global $cpinfo;

$trackid = $command->id;
$trackuid = $command->uid;


$dbcp = $cpinfo->arrayQuery("SELECT challengeid, playerid, checkpoints, score, pl.login
from records rs,players pl where pl.login = (select login from players as p where rs.playerid = p.id) and score = (select min(score) from records as r where r.playerid = rs.playerid and challengeid=$trackid) order by score;");
if (!empty($dbcp)) {
foreach ($dbcp as $data) {
$array[$data['login']] = array("score" =>$data['score'], "checkpoints" => $data['checkpoints']);
}

$best = array("score" =>$dbcp[0]['score'], "checkpoints" => $dbcp[0]['checkpoints']);
}

unset($cpinfo->Records);
unset($cpinfo->Best);
$cpinfo->trackId = $trackid;
$cpinfo->Records = $array;
$cpinfo->Best = $best;
}

function cpinfo_checkpoint($aseco, $command) {
global $cpinfo;
global $aseco;
unset($record);
unset($bestrecord);
unset($times);
unset($besttime);
$playerid = $command[0];
$login = $command[1];

$time1 = $command[2];
$cp = $command[4];
$record = $cpinfo->Records[$login];	
$bestrecord = $cpinfo->Best;
$times = explode(",",$record['checkpoints']);
$besttime = explode(",",$bestrecord['checkpoints']);


$timediff = $time1 - $times[$cp];
if ($timediff < 0) { $time3 = "\$00f-".formatTime(abs($timediff)); } else { $time3 = "\$f00+".formatTime(abs($timediff)); } 
$bestdiff = $time1 - $besttime[$cp];
if ($bestdiff < 0) { $best = "\$00f-".formatTime(abs($bestdiff)); } else { $best = "\$f00+".formatTime(abs($bestdiff)); } 


$xml = $cpinfo->getManialink($cp,$time3,$best);   // get manialink code 

	if ($cpinfo->force_show == 'true') { // check if should display for always
		print "Cpinfo (forced): $login";
		$aseco->client->query("SendDisplayManialinkPageToLogin", $login, $xml, (int)$cpinfo->timeout, false); 
	} else {
		$player = $aseco->server->players->getPlayer($login);
		if (isset($player->cpinfo) && $player->cpinfo == 1 ) {
		print "Cpinfo: $login";
		$aseco->client->query("SendDisplayManialinkPageToLogin", $login, $xml, (int)$cpinfo->timeout, false); 
		}
	}
}

function cpinfo_end($aseco, $command) {
global $cpinfo;
$xml = '<?xml version="1.0" encoding="UTF-8"?>';
$xml .= '<manialink id="'.$cpinfo->manialink_id.'"></manialink>';
$aseco->client->query("SendDisplayManialinkPage", $xml, 0, false); 
}

function cpinfo_finish($aseco, $command) {
global $cpinfo;
$login = $command->player->login;

$xml = '<?xml version="1.0" encoding="UTF-8"?>';
$xml .= '<manialink id="'.$cpinfo->manialink_id.'"></manialink>';
$aseco->client->query("SendDisplayManialinkPageToLogin", $login, $xml, 0, false); 

$trackid = $cpinfo->trackId;
$dbcp = $cpinfo->arrayQuery("SELECT challengeid, playerid, checkpoints, score, pl.login
from records rs,players pl where pl.login = (select login from players as p where rs.playerid = p.id) and score = (select min(score) from records as r where r.playerid = rs.playerid and challengeid=$trackid) order by score;");
if (!empty($dbcp)) {
foreach ($dbcp as $data) {
$array[$data['login']] = array("score" =>$data['score'], "checkpoints" => $data['checkpoints']);
}

$best = array("score" =>$dbcp[0]['score'], "checkpoints" => $dbcp[0]['checkpoints']);
}

unset($cpinfo->Records);
unset($cpinfo->Best);
$cpinfo->trackId = $trackid;
$cpinfo->Records = $array;
$cpinfo->Best = $best;
}


		
		
class cpinfo_class
{
public $pb_posn_x, $pb_posn_y, $text_color,$manialink_id,$timeout,$force_show;
public $local1_posn_x, $local1_posn_y;
public $Aseco;
public $Records,$trackId,$Best;

	function Startup() {
		//settings from config-file
		$settings = simplexml_load_file('cpinfo.xml');
	
		$this->pb_posn_x = $settings->personal_best->hx;
		$this->pb_posn_y = $settings->personal_best->vy;
		$this->local1_posn_x = $settings->local1->hx;
		$this->local1_posn_y = $settings->local1->vy;
		$this->text_color = $settings->colors->text_color;
		$this->manialink_id = $settings->manialink_id;
		$this->timeout = $settings->timeout;
		$this->force_show = $settings->enable_for_all;
	
		$this->Aseco->client->query('GetCurrentChallengeInfo');
	    $test = $this->Aseco->client->getResponse();
		$result=$this->arrayQuery("SELECT Id FROM challenges WHERE Uid='" .$test['UId']."';");
		$this->trackId=$result[0]['Id'];
		
	}

	function getManialink($cp, $time2, $best) {
		$cp = $cp+1;
		$xml = '<?xml version="1.0" encoding="UTF-8"?>';
		$xml .= '<manialink id='.$this->manialink_id.'>';
		$xml .= '<frame posn="'.$this->pb_posn_x.' '.$this->pb_posn_y.' 0.3">';
		$xml .= '<label scale="0.8" posn="-9.6 15.5 0.1" halign="center" valign="center" text="$s$'.$this->text_color.'Personal Best"/>';
		$xml .= '<label scale="0.6" posn="-15.6 17.7 0.1" halign="left" valign="center" style="TextRaceChrono" text="$s'.$time2.'"/>';
		$xml .= '</frame>';
		
		$xml .= '<frame posn="'.$this->local1_posn_x.' '.$this->local1_posn_y.' 0.3">';
		$xml .= '<label scale="0.8" posn="-8.6 15.5 0.1" halign="center" valign="center" text="$s$'.$this->text_color.'Local 1"/>';
		$xml .= '<label scale="0.6" posn="-15.6 17.7 0.1" halign="left" valign="center" style="TextRaceChrono" text="$s'.$best.'"/>';
		$xml .= '</frame>';
		
		$xml .= '</manialink>';
		return $xml;
	}
	
	function arrayQuery($query) 
	{
		$q = mysql_query($query);
		$error = mysql_error();
		if(strlen($error)) 
			{
			trigger_error('[plugin.CPinfo.php] Error with MYSQL query! '.$error, E_USER_ERROR);
			die();
			}
		while(true) 
			{
			$row = mysql_fetch_assoc($q);
			if(!$row)
			break;
			$data[]=$row;
			}	
		mysql_free_result($q);
		return $data;
	}
}

?>
